﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;

namespace createTemplateREST
{
    public class createTemplateREST
    {
        public static void Main(string[] args)
        {

            //replace api_key placeholder with your own value
            string API_KEY = "api_key";
            string API_URL = "https://sandbox.e-signlive.com/api";

            //Email, SMS, and Q&A signer authentication
            string jsonString = "{ \"roles\":[ { \"locked\":false, \"id\":\"Signer1\", \"type\":\"SIGNER\", \"index\":0, \"signers\":[ { \"auth\": { \"challenges\":[ { \"question\": \"What's your favorite sport?\", \"answer\": \"golf\", \"maskInput\": false } ], \"scheme\":\"CHALLENGE\" }, \"firstName\":\"First\", \"lastName\":\"Signer\", \"email\":\"first.signer@example.com\", \"knowledgeBasedAuthentication\":null, \"language\":\"en\", \"external\":null, \"delivery\": { \"email\":true, \"provider\":false, \"download\":true } }], \"name\":\"Signer1\" }, { \"locked\":false, \"emailMessage\": { \"content\":\"\" }, \"attachmentRequirements\":[], \"reassign\":false, \"specialTypes\":[], \"id\":\"Signer2\", \"data\":null, \"type\":\"SIGNER\", \"index\":0, \"signers\":[ { \"auth\": { \"challenges\":[ { \"question\": \"15145862225\" } ], \"scheme\":\"SMS\" }, \"firstName\":\"Second\", \"lastName\":\"Signer\", \"email\":\"second.signer@example.com\", \"knowledgeBasedAuthentication\":null, \"language\":\"en\", \"external\":null, \"delivery\": { \"email\":false, \"provider\":false, \"download\":false } }], \"name\":\"Signer2\" }], \"documents\":[ { \"approvals\":[ { \"role\":\"Signer1\", \"fields\":[ { \"page\":0, \"width\":200, \"left\":175, \"top\":165, \"height\":50, \"type\":\"SIGNATURE\" }], \"name\":\"Signer1\" }, { \"role\":\"Signer2\", \"fields\":[ { \"page\":0, \"width\":200, \"left\":550, \"top\":165, \"height\":50, \"type\":\"SIGNATURE\" }], \"name\":\"Signer2\" }], \"name\": \"My document\" }], \"name\": \"Signer Authentication Method\", \"type\":\"PACKAGE\", \"description\":\"Sample Test\", \"autoComplete\":true, \"status\":\"SENT\" }";
            //The sample JSON string below shows you how to edit the “signers” object with KBA. The “withTimeAtAddress” field can be left empty. Note that this is not a valid JSON request.
            string jsonString2 = "{ \"signers\":[ { \"delivery\":{ \"email\":false }, \"email\":\"signer@example.com\", \"firstName\":\"John\", \"lastName\":\"Doe\", \"auth\":{ \"scheme\":\"NONE\", \"challenges\":[ ] }, \"knowledgeBasedAuthentication\":{ \"signerInformationForEquifaxUSA\":{ \"firstName\":\"John\", \"lastName\":\"Doe\", \"streetAddress\":\"2020 Broadway Street\", \"city\":\"New York\", \"zip\":\"12345\", \"state\":\"NY\", \"timeAtAddress\":5, \"driversLicenseNumber\":\"1234567890\", \"dateOfBirth\":\"1969-12-09T00:00:00Z\", \"socialSecurityNumber\":\"123456789\", \"homePhoneNumber\":\"1234567890\" } } } ], \"reassign\":false, \"emailMessage\":{ \"content\":\"\" }, \"attachmentRequirements\":[ ] }";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json"); 

            byte[] fileByteArray = File.ReadAllBytes("DOCUMENT_FILE_PATH");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"FILE_NAME.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"FILE_NAME.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", API_KEY);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(API_URL) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}